
//	Copyright 2010 PaletteSoft LLC

// ***************************************************************************
// *	dl															 *
// ***************************************************************************
/*
	kdc\Tv@̂Q	PIC12F683	CLOCK:INTRCIO/4MHz

	GP0:LED0	Out	0:A1:_
	GP1:LED1	Out	0:A1:_
	GP2:LED2	Out	0:A1:_
	GP3:MCLR	-----
	GP4:SW1		In	0:IA1:It	vAbvp̂
	GP5:SW0		In	0:IA1:It	vAbvp̂

	XCb`̃ItǏoiIGbWoj񐔂kdcłQi\B
	kdc̃rbgʒu͎AkraB񐔂̉ʂRrbg\ɔfB

	rvÓ{PArvṔ|Pɉ񐔂XV

	LED			*:_A.:
	012 Count
	...	0		ȎO͌ʓIɂV
	*..	1
	.*.	2		@{PFrvO
	**.	3
	..*	4
	*.* 5			|PFrvP
	.** 6
	*** 7		V̎͌ʓIɂO
*/

// ***************************************************************************
// *	CN[ht@C												 *
// ***************************************************************************

#include	<pic.h>														//	vWFNgݒőIꂽfoCXIɈp܂

// ***************************************************************************
// *	vOo[W												 *
// ***************************************************************************

#define	VER1					1										//	ʏ\̈	PŎwip֎~j
#define	VER2					0										//	ʈ̈	PŎwip֎~j
//								.
#define	VER3					4										//	ʏ\̈	PŎwip֎~j
#define	VER4					1										//	ʈ̈	PŎwip֎~j

#define	COPYRIGHT				"Copyright 2010 PaletteSoft LLC"		//	쌠

// ***************************************************************************
// *																 *
// ***************************************************************************

	//	*****  *****

__CONFIG(	FCMDIS														//	tF[Z[tNbNj^֎~
		&	IESODIS														//	ONbÑXCb`I[o[[h֎~
		&	BORDIS														//	uEAEgo֎~
		&	UNPROTECT													//	f[^iEEPROMj̃veNg֎~
		&	UNPROTECT													//	vÕveNg֎~
		&	MCLREN														//	GP3/_MCLR[q_MCLRŗpiIɃvAbvj
		&	PWRTEN														//	p[Abv^C}싖
		&	WDTDIS														//	EHb`hbO^C}֎~
		&	INTIO														//	NbNpRA4ARA5[q͓o͂ŗp
);

	//	***** hc *****

__IDLOC7(VER1, VER2, VER3, VER4);										//	o[WԍƂĒ`ïӖt͔CӁj

// ***************************************************************************
// *	f[^^															 *
// ***************************************************************************

typedef	unsigned char			UB;										//	PoCgf[^^
typedef	unsigned short			UH;										//	QoCgf[^^
typedef	unsigned int			UINT;									//	Ȃ

// ***************************************************************************
// *	Œl																 *
// ***************************************************************************

	//	***** XCb`̈ʒu *****

#define	SW0						0b00100000								//	rvÕrbgʒu
#define	SW1						0b00010000								//	rvP̃rbgʒu

	//	***** `^O *****

#define	SW_CHAT_MAX				5										//	ϐ̓sōőQTT	c@񐔂Ɣ݂Ȃ

// ***************************************************************************
// *	O[oϐ														 *
// ***************************************************************************

	//	***** o̓|[g̃obNAbv *****

union {
	UB	BYTE;															//	oCgANZXp
	struct {
		UINT	Led		: 3;											//	kdc				c@ʂRrbg
		UINT	Dummy	: 5;											//	_~[
	} BIT;
} vPortData;															//	o̓|[g̃obNAbv

	//	***** XCb` *****

struct {
	UB		Status;														//	ݏ
	UB		Result;														//	m
	UB		Count;														//	v
} vSwInfo;

// ***************************************************************************
// *	e[u															 *
// ***************************************************************************


// ***************************************************************************
// *	}N錾															 *
// ***************************************************************************


// ***************************************************************************
// *	vg^Cv錾													 *
// ***************************************************************************

void	main(void);

UB		SwGet(void);
void	SwChatInit(void);
void	SwChatExcute(UB Status);
UB		SwChatGet(void);

void	DevInit(void);
void	TmInit(void);

// ***************************************************************************
// *	{															 *
// ***************************************************************************

//============================================================================
//	C
//----------------------------------------------------------------------------
//	́F	
//	óF	
//----------------------------------------------------------------------------
//	lF	X^[gAbv[`̃Wv߂ŌĂяo܂B
//			{֐͖[vłAEo邱Ƃ͂܂B
//============================================================================
void	main(void)
{
	UB		SwData;														//	XCb`f[^
	UB		SwBefore;													//	ÕXCb`f[^	c@IGbWop
	UB		SwEdge;														//	GbWopf[^

	UB		LedData;													//	kdcf[^			c@񐔂Ƃėp̂\ɂ]p

	//	***** ͂߂ *****

	di();																//	Ă̊荞݋֎~𖾎
	DevInit();															//	foCXݒ
	TmInit();															//	^C}ݒ

	//	***** XCb`̃`^Ȍ *****

	SwChatInit();														//	XCb`̏ݒ
	SwBefore = SwChatGet();												//	݂̊mԂ擾

	LedData = 0;														//	kdcf[^NA

	//	*****  *****

	while (1) {															//	[vł

		//	***** TvO^C~OmF *****

		if (T0IF) {														//	^C}OvH	c@荞ݗv͊荞݋֎~Lɂ炸
			T0IF = 0;													//	^C}Ov	c@vZ512usŊ荞ݗv

			//	***** XCb`̎擾Ɛ *****

			SwData = SwGet();											//	XCb`̎擾

#if 1																	//	PF`^OsAOF`^OsȂ
			SwChatExcute(SwData);										//	XCb`̃`^O
			SwData = SwChatGet();										//	݂̃XCb`mԂ擾	c@mԂߋ̏Ԃ̏ꍇ
#endif

			//	***** ItIւ̕ωo *****					//	_␳ς݂̏ɑ΂āAOPւ̕ω

			SwEdge = (SwBefore ^ SwData) & SwData;						//	OOōP̃rbĝ݂PɂȂB
			SwBefore = SwData;											//	񔻒pɍ̏Ȍ

			//	***** ω̏Ԃkdcf[^ɔf *****

			if (SwEdge & SW0) {											//	rvÕIoH
				LedData ++;												//	񐔂{P
			}
			if (SwEdge & SW1) {											//	rvP̃IoH
				LedData --;												//	񐔂|P
			}

			//	***** kdcf[^o *****

			vPortData.BIT.Led = LedData;								//	kdco̓f[^XV	c@RpCrbgʒu킹
			GPIO = vPortData.BYTE;										//	o̓|[gꊇҏW	c@rbgɂRead&ModifysȂ@
		}
	}
}

//============================================================================
//	XCb`擾
//----------------------------------------------------------------------------
//	́F	
//	óF	XCb`̏ԁij
//----------------------------------------------------------------------------
//	lF	XCb`̏Ԃ擾Ę_␳܂B
//============================================================================
UB		SwGet(void)
{
	UB		Status;														//	XCb`

	//	***** f[^擾 *****

	Status = GPIO;														//	o̓|[g̓ǂݏo

	//	***** _␳ *****

	Status = (~Status) & (SW0 | SW1);									//	_]ALrbg}XN	c@GP5:SW0, GP4:SW1

	//	***** ܂ *****

	return(Status);														//	XCb`̏ԂԂ܂
}

//============================================================================
//	XCb`̏ݒ
//----------------------------------------------------------------------------
//	́F	
//	óF	
//----------------------------------------------------------------------------
//	lF	XCb`̃`^Op̏ݒ肵܂B
//============================================================================
void	SwChatInit(void)
{
	vSwInfo.Result = vSwInfo.Status = SwGet();							//	݂̃XCb`̏ԂmԂƂ
	vSwInfo.Count = SW_CHAT_MAX;										//	XCb`̏Ԃ肵ĂƑz
}

//============================================================================
//	XCb`̃`^O
//----------------------------------------------------------------------------
//	́F	ŐṼXCb`̏
//	óF	
//----------------------------------------------------------------------------
//	lF	XCb`̃`^Os܂B
//============================================================================
void	SwChatExcute(UB Status)
{
	//	***** ωo *****

	if (Status == vSwInfo.Status) {										//	ƑO͈vH

		//	***** XCb`̈mF *****

		if (vSwInfo.Count < SW_CHAT_MAX) {								//	҂H

			vSwInfo.Count ++;											//	v񐔍XV
			if (vSwInfo.Count >= SW_CHAT_MAX) {							//	̍ƂɂmFH

				//	***** XCb`芮 *****

				vSwInfo.Result = vSwInfo.Status;						//	ƒ̏m
			}
		}
		else {															//	Ɉ肵Ă
			;															//	ɂȂ
		}
	}
	else {																//	ƑO͈قȂ

		//	***** VȏԂ *****

		vSwInfo.Status = Status;										//	̏OփZbg
		vSwInfo.Count = 1;												//	P
	}
}

//============================================================================
//	݂̃XCb`mԂ擾
//----------------------------------------------------------------------------
//	́F	
//	óF	XCb`̊m
//----------------------------------------------------------------------------
//	lF	XCb`̊mԂԂ܂B
//============================================================================
UB		SwChatGet(void)
{
	return(vSwInfo.Result);												//	mԂ܂
}

//============================================================================
//	foCXݒ
//----------------------------------------------------------------------------
//	́F	
//	óF	
//----------------------------------------------------------------------------
//	lF	foCX̏ݒs܂B
//			Zbg̏lōςޏꍇ͍Đݒ肵Ă܂B
//============================================================================
void	DevInit(void)
{
	//	***** { *****

//						  76543210
	OPTION =			0b01111111;										//	IvVWX^
																		//	bit07:GPPU		0	̓|[g̃vAbv			
																		//	bit06:INTEDG	1	O荞݂͗オGbW		gp
																		//	bit05:T0CS		1	^C}O͊ONbN𗘗p		gp
																		//	bit04:T0SE		1	^C}O̍XV͗GbW		gp
																		//	bit03:PSA		1	vXP[͂vcsŗp			gp
																		//	bit02:PS2		1	vXP[͂PQW			gp
																		//	bit01:PS1		1		ij
																		//	bit00:PS0		1		ij

	//	***** o̓|[g *****										//	ӁFĂ̏ꍇAėpo̓|[g͕ʋ@\Ă

//						  76543210
	vPortData.BYTE =	0b00000000;										//	ėpo̓|[gf[^̏l
																		//	bit07:-----		0
																		//	bit06:-----		0
																		//	bit05:GP5		0	́FrvO						͂Ȃ̂ŖӖ
																		//	bit04:GP4		0	́FrvP						͂Ȃ̂ŖӖ
																		//	bit03:GP3		0	́Flbkq						w͖
																		//	bit02:GP2		0	óFkdcQ						
																		//	bit01:GP1		0	óFkdcP						
																		//	bit00:GP0		0	óFkdcO						

	GPIO = vPortData.BYTE;												//	o̓|[gꊇҏW	c@rbgɂRead&ModifysȂ@

//						  76543210
	CMCON0 =			0b00000111;										//	Rp[^
																		//	bit07:-----		0
																		//	bit06:COUT		0	Rp[^o͏				ǂݏô݉
																		//	bit05:-----		0
																		//	bit04:CINV		0	o͔]Ȃ						gp
																		//	bit03:CIS		0	̓XCb`ݒ					gp
																		//	bit02:CM2		1	Rp[^It					
																		//	bit01:CM1		1		ij						
																		//	bit00:CM0		1		ij						

//						  76543210
	ANSEL =				0b00000000;										//	AiOZN^
																		//	bit07:-----		0
																		//	bit06:ADCS2		0	`cϊNbNI				gp
																		//	bit05:ADCS1		0		ij
																		//	bit04:ADCS0		0		ij
																		//	bit03:ANS3		0	`mRgpAfoSėpo		
																		//	bit02:ANS2		0	`mQgpAfoQėpo		
																		//	bit01:ANS1		0	`mPgpAfoPėpo		
																		//	bit00:ANS0		0	`mOgpAfoOėpo		

//						  76543210
	TRISIO =			0b00111000;										//	ėpo̓|[g
																		//	bit07:-----		0
																		//	bit06:-----		0
																		//	bit05:GP5		1	́FrvO						
																		//	bit04:GP4		1	́FrvP						
																		//	bit03:GP3		1	́Flbkq						ǂݏô݉
																		//	bit02:GP2		0	óFkdcQ						
																		//	bit01:GP1		0	óFkdcP						
																		//	bit00:GP0		0	óFkdcO						
}

//============================================================================
//	^C}ݒ
//----------------------------------------------------------------------------
//	́F	
//	óF	
//----------------------------------------------------------------------------
//	lF	^C}Ȍݒs܂B
//			SlǧUAQݒ̏ꍇTPQʂŃ^CAEgB
//============================================================================
void	TmInit(void)
{
	//	***** ^C}Õ[hݒ *****

	CLRWDT();															//	vcs̃tbV	c@ʓIɓ삵ĂȂ̂Ōʖ
																		//								f[^V[gɋLڂĂ@𓥏P
//						 76543210	   76543210
	OPTION = (OPTION & 0b11010000) | 0b00000000;						//	IvVWX^		c@ݒς݂̒lC
																		//	bit07:GPPU		*	iύXȂj
																		//	bit06:INTEDG	*	iύXȂj
																		//	bit05:T0CS		0	^C}O͓NbN𗘗p		
																		//	bit04:T0SE		*	iύXȂj
																		//	bit03:PSA		0	vXP[̓^C}Oŗp		
																		//	bit02:PS2		0	vXP[͂Q				
																		//	bit01:PS1		0		ij
																		//	bit00:PS0		0		ij

	//	***** ^C}Õ^CAEg󋵂 *****

	TMR0 = 0;															//	^C}OJE^̃NAivXP[ɃNAj
	T0IE = 0;															//	^C}O͋֎~
	T0IF = 0;															//	^C}Ov	c@slqOWX^̃I[o[t[
}

// ***************************************************************************
// ***************************************************************************
// *																		 *
// ***************************************************************************
// ***************************************************************************

//	Copyright 2010 PaletteSoft LLC

